/* clean_filespecs() */

#include <tt.h>

static boolean invalid_file_character(int c)
{
  return c<=' ' || c=='"' || c=='/' || c=='\\' || c=='[' || c==']' ||
         c==':' || c=='|' || c=='<' || c=='>'  || c=='+' || c=='=' ||
         c==';' || c==',' || c=='.' || c>'~';
}

filespecs_type clean_filespecs(char *s)
{
  enum filespecs_type type;
  char *t;
  for (t=s; *t!=0; t++) if ('a'<=*t && *t<='z') *t -= ('a'-'A');
  if ('A'<=s[0] && s[0]<='Z' && s[1]==':')
  {
    t = s+2;
    type = FS_DRIVE;
  }
  else {t = s; type = FS_NOTHING;}
  while (*t!=0)
  {
    if (*t=='\\')
    {
      if (type==FS_AMBIGUOUS_FILE || type==FS_DIRECTORY) return FS_ERROR;
      type = FS_DIRECTORY;
      t++;
    }
    else if (*t=='.')
    {
      if (*++t=='.') t++;
      if (*t=='\\') t++; else if (*t!=0) return FS_ERROR;
      type = FS_DIRECTORY;
    }
    else
    {
      unsigned i = 0;
      type = FS_FILE_OR_DIRECTORY;
      do
      {
        if (*t=='*')
        {
          if (i==8) return FS_ERROR;
          type = FS_AMBIGUOUS_FILE;
          i = 7;
        }
        else if (*t=='?') type = FS_AMBIGUOUS_FILE;
        else if (invalid_file_character(*t)) return FS_ERROR;
        if (i<8) {i++; t++;}
        else string_copy(t, t+1);
      } while (*t!='.' && *t!=0 && *t!='\\');
      if (*t=='.')
      {
        t++;
        i = 0;
        while (*t!=0 && *t!='\\')
        {
          if (*t=='*')
          {
            if (i==3) return FS_ERROR;
            type = FS_AMBIGUOUS_FILE;
            i = 2;
          }
          else if (*t=='?') type = FS_AMBIGUOUS_FILE;
          else if (invalid_file_character(*t)) return FS_ERROR;
          if (i<3) {i++; t++;}
          else string_copy(t, t+1);
        }
      }
      if (*t!='\\' && *t!=0) return FS_ERROR;
    }
  }
  return type;
}
