; start_fast_clock(), stop_fast_clock(), fast_ticks(), clear_fast_ticks()

IVEC    =       8*4

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

_DATA   SEGMENT WORD PUBLIC 'DATA'

LS_TICKS  DW  0
MS_TICKS  DW  0

_DATA   ENDS

DGROUP  GROUP   _TEXT, _DATA

_TEXT   SEGMENT
        ASSUME  CS:DGROUP

ISR     PROC    FAR
        ASSUME  DS:NOTHING
        ADD     LS_TICKS,1
        ADC     MS_TICKS,0
        CMP     BYTE PTR LS_TICKS,0
        JNZ     ISR2
        DB      0EAH    ; intersegment jump
        ASSUME  DS:DGROUP
IOFS    DW      (?)
ISEG    DW      (?)
ISR2:   PUSH    AX
        MOV     AL,20H
        OUT     20H,AL
        POP     AX
        IRET
ISR     ENDP

        ASSUME  DS:DGROUP

        PUBLIC  _start_fast_clock

_start_fast_clock PROC NEAR

        MOV     AH,2CH
        INT     21H
        MOV     BL,DL
WAIT1:  MOV     AH,2CH
        INT     21H
        CMP     BL,DL
        JZ      WAIT1
        SUB     AX,AX
        MOV     ES,AX
        MOV     AX,ES:IVEC
        MOV     IOFS,AX
        MOV     AX,ES:(IVEC+2)
        MOV     ISEG,AX
        MOV     WORD PTR ES:IVEC,OFFSET DGROUP:ISR
        MOV     WORD PTR ES:(IVEC+2),CS
        MOV     AL,36H
        OUT     43H,AL
        SUB     AL,AL
        OUT     40H,AL
        INC     AX
        OUT     40H,AL
        RET

_start_fast_clock ENDP

        PUBLIC  _stop_fast_clock

_stop_fast_clock PROC NEAR

        MOV     AL,BYTE PTR LS_TICKS+1
WAIT2:  CMP     AL,BYTE PTR LS_TICKS+1
        JZ      WAIT2
        SUB     AX,AX
        MOV     ES,AX
        MOV     AX,IOFS
        MOV     WORD PTR ES:IVEC,AX
        MOV     AX,ISEG
        MOV     WORD PTR ES:(IVEC+2),AX
        MOV     AL,36H
        OUT     43H,AL
        SUB     AL,AL
        OUT     40H,AL
        OUT     40H,AL
        RET

_stop_fast_clock ENDP

        PUBLIC  _fast_ticks

_fast_ticks PROC NEAR

        PUSHF
        CLI
        MOV     AX,LS_TICKS
        MOV     DX,MS_TICKS
        POPF
        RET

_fast_ticks ENDP

        PUBLIC  _clear_fast_ticks

_clear_fast_ticks PROC NEAR

        MOV     LS_TICKS,0
        MOV     MS_TICKS,0
        RET

_clear_fast_ticks ENDP

_TEXT   ENDS
        END

