/* redirected_key() */

#include <tt.h>

unsigned redirected_key(void)
{
  static int i = 0;
  static int n = 0;
  static unsigned char buffer[512];
  static enum {BEGIN, KEYBOARD, FILE0, FILE1, FILE2, END} source = BEGIN;
  unsigned k;
  switch (source)
  {
    case BEGIN:
      source = is_device(0) ? KEYBOARD : FILE1;
      k = 0;
      break;
    case FILE0:
      k = 0;
      source = FILE1;
      break;
    case KEYBOARD:
      k = key();
      break;
    case FILE1: case FILE2:
      if (i>=n)
      {
        n = read(0, buffer, sizeof(buffer));
        if (n<=0)
        {
          k = 0;
          source = END;
          break;
        }
        i = 0;
      }
      k = buffer[i++];
      if (source == FILE2)
      {
        k += 256;
        source = FILE0;
      }
      else if (k == 0) source = FILE2;
      else source = FILE0;
      break;
    case END:
      k = redirected_key_eof();
  }
  return k;
}
